import logging
from dataclasses import dataclass

from fasthtml import serve
from fasthtml.components import *

from myfasthtml.controls.helpers import mk
from myfasthtml.core.bindings import Binding
from myfasthtml.core.utils import debug_routes
from myfasthtml.myfastapp import create_app

logging.basicConfig(
  level=logging.DEBUG,  # Set logging level to DEBUG
  format='%(asctime)s - %(name)s - %(levelname)s - %(message)s',  # Log format
  datefmt='%Y-%m-%d %H:%M:%S',  # Timestamp format
)

app, rt = create_app(protect_routes=False)


@dataclass
class Data:
  value: str = "Hello World"
  checked: bool = False


data = Data()


@rt("/")
def get():
  radio1 = Input(type="radio", name="radio_name", value="option1")
  radio2 = Input(type="radio", name="radio_name", value="option2", checked=True)
  radio3 = Input(type="radio", name="radio_name", value="option3")
  label_elt = Label("hi hi hi !")
  
  mk.manage_binding(radio1, Binding(data))
  mk.manage_binding(radio2, Binding(data))
  mk.manage_binding(radio3, Binding(data))
  mk.manage_binding(label_elt, Binding(data))
  
  return radio1, radio2, radio3, label_elt


if __name__ == "__main__":
  debug_routes(app)
  serve(port=5002)
